﻿Public Class frmBar
    Private pDrive() As PictureBox

    Private Sub frmBar_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load

        Dim i As Integer
        Dim imWidth, imHeight As Integer
        Dim pBitmap As System.Drawing.Bitmap
        Dim itemRectangle As Rectangle

        GetSettings()
        pBitmap = My.Resources.rPanel.battery1 ' получаем рисунок (линейка значков батарей) из ресурса
        pBitmap.MakeTransparent() ' Убираем фон
        imWidth = pBitmap.Width - 1 ' Получаем длину линейки
        imHeight = pBitmap.Height ' Получаем высоту линейки

        For i = 0 To 9 ' Цикл по количеству значков (10)
            itemRectangle.Height = imHeight ' получаем регион описывающий i-ый значёк
            itemRectangle.Width = imWidth \ 10
            itemRectangle.X = (imWidth \ 10) * i
            itemRectangle.Y = 0

            BatteryIm(i).Location = itemRectangle 'Запоминаем в массив регион
            ' Помещаем копию описанную регионом в структуру
            BatteryIm(i).Item = pBitmap.Clone(itemRectangle, Imaging.PixelFormat.DontCare)

        Next i


        Me.Left = 0
        Me.Top = 0
        Me.Height = 35
        DriveUpdate()
        'Расстановка значков
        PictureBox1.Left = (Me.Width - PictureBox1.Width) - 5
        PictureBox2.Left = (PictureBox1.Left - PictureBox2.Width) - 5
        lblTime.Text = Format$(Now(), "dd.mm.yyyy - hh:mm")
        LineShape2.X1 = PictureBox2.Left - 5
        LineShape2.X2 = LineShape2.X1
        lblTime.Left = (LineShape2.X1 - lblTime.Width) - 10
        LineShape1.X1 = lblTime.Left - 10
        LineShape1.X2 = LineShape1.X1

    End Sub
    Private Sub DriveUpdate()


        Dim cDrive As System.IO.DriveInfo                       ' Информация о диске

        Dim sDrive As String                                    ' Хранит букву диска
        Dim iCount As Integer                                   ' Количество дисков в системе
        Dim i As Integer
        Static cnt As Integer                                   ' Количество экземпляров значков дисков

        iCount = My.Computer.FileSystem.Drives.Count            ' Получаем количество дисков

        If cnt <> iCount Then                                   ' Если количество дисков и значков не совпадает
            If cnt > iCount Then                                ' и если значков больше чем дисков
                For i = iCount To cnt - 1
                    RemoveHandler pDrive(i).MouseMove, AddressOf EventHandler ' Высвобождаем указатель на обработчик события



                Next i
                For i = cnt - 1 To iCount Step -1
                    Me.Controls.Remove(Me.pDrive(i))            ' Удаляем значки
                Next i

            End If
            cnt = iCount                                        ' запоминаем количество значков


            ReDim pDrive(iCount - 1)                            ' Меняем размерность массива значков
            For i = 0 To iCount - 1                             ' Цикл по количеству дисков 


                sDrive = My.Computer.FileSystem.Drives.Item(i).ToString ' Получаем букву диска
                cDrive = My.Computer.FileSystem.GetDriveInfo(sDrive)    ' Получаем информацию о диске
                pDrive(i) = New PictureBox                              ' Создаём новый экземпляр картинки

                AddHandler pDrive(i).MouseMove, AddressOf EventHandler  ' Передаём указатель на MouseMove
                ''''''''''''''''''''''''''''''''''''''''''''''''''''''''' в другую процедуру.

                Me.Controls.AddRange(pDrive)                                      ' добавить значёк

                pDrive(i).Height = 25                                           ' Высота значка
                pDrive(i).Width = 25                                            ' Длина значка
                pDrive(i).SizeMode = PictureBoxSizeMode.StretchImage            ' Растянуть картинку в значке
                Select Case cDrive.DriveType                                    ' Получить тип диска  
                    Case IO.DriveType.Fixed                                     ' и загрузить картинку из
                        pDrive(i).Image = My.Resources.rPanel.HARD.ToBitmap     ' ресурса.
                    Case IO.DriveType.CDRom
                        pDrive(i).Image = My.Resources.rPanel.CDDVD.ToBitmap
                    Case IO.DriveType.Network
                        pDrive(i).Image = My.Resources.rPanel.NET.ToBitmap
                    Case IO.DriveType.NoRootDirectory
                        pDrive(i).Image = My.Resources.rPanel.netu.ToBitmap
                    Case IO.DriveType.Ram
                        pDrive(i).Image = My.Resources.rPanel.RAM.ToBitmap
                    Case IO.DriveType.Removable
                        pDrive(i).Image = My.Resources.rPanel.usb.ToBitmap
                    Case IO.DriveType.Unknown
                        pDrive(i).Image = My.Resources.rPanel.usb.ToBitmap

                End Select
                '''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''Расстановка значков
                pDrive(i).Left = 75 + i * (pDrive(i).Width + 5)
                pDrive(i).Top = 5
                pDrive(i).BorderStyle = BorderStyle.None
                pDrive(i).BackColor = Color.Transparent
                pDrive(i).ContextMenuStrip = mnuDisk
                pDrive(i).Tag = sDrive
                LineShape4.X1 = pDrive(i).Left + pDrive(i).Height + 5
                LineShape4.X2 = LineShape4.X1
                Button2.Left = LineShape4.X1 + 5
                Button3.Left = Button2.Left + Button2.Width + 5

            Next i
        End If
        'For i = 0 To User_but_count - 1
        'pButton(i).Left = LineShape4.X1 + 5 + i * (pButton(i).Width + 10)
        'Next i
        ' ----------------------
    End Sub
    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        Dim p As System.Drawing.Point
        p.X = 0 : p.Y = Me.Button1.Height

        BarMenu.Show(Me.Button1, p)
    End Sub
   
    Private Sub ToolStripMenuItem2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)
        End

    End Sub
    Private Sub Ttime_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Ttime.Tick
        ' растягиваем панель по ширине экрана
        Me.Width = My.Computer.Screen.WorkingArea.Width
        ' отображаем текущее время и дату
        lblTime.Text = Format$(Now(), "dd.mm.yyyy - hh:mm")
        ' обновляем информацию о дисках
        DriveUpdate()

    End Sub
    Private Sub ОткрытьToolStripMenuItem_Click_1(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ОткрытьToolStripMenuItem.Click
        
    End Sub
    Private Sub СвойстваToolStripMenuItem_Click_1(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles СвойстваToolStripMenuItem.Click
        sDN = mnuDisk.SourceControl.Tag() ' получаем букву выбранного диска
        GetDriveInf(sDN) ' вызываем окно свойств диска
        ' запуск таймера обновления свойств диска
        frmDriveCaption.Timer1.Enabled = True
    End Sub
    
    Private Sub EventHandler(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs)

        '' Обработка события Mouse Move ' Отображение Tool Tip с краткой информацией
        '   о диске
        '  |=========================|
        '  |                         |
        '  |  Диск <буква>           |
        '  | [Метка],[файл. система] |
        '  | Свободно на диске       |
        '  |=========================|
        '
        Dim sCaption As String
        Dim cDr As System.IO.DriveInfo
        cDr = My.Computer.FileSystem.GetDriveInfo(sender.Tag)
        If Not cDr.IsReady Then
            ToolTip.SetToolTip(sender, "Диск " & Mid(sender.Tag, 1, 2) & vbCrLf & "[Нет диска]")
            Exit Sub
        End If
        If Not cDr.VolumeLabel = vbNullString Then
            sCaption = "Диск " & Mid(sender.Tag, 1, 2) & vbCrLf & " [" & cDr.VolumeLabel & "] , [" & cDr.DriveFormat & "]" & vbCrLf & "Свободно: " & Formatdata(cDr.AvailableFreeSpace / 1024 / 1024)
        Else
            sCaption = "Диск " & Mid(sender.Tag, 1, 2) & vbCrLf & " [Без метки] , [" & cDr.DriveFormat & "]" & vbCrLf & "Свободно: " & Formatdata(cDr.AvailableFreeSpace / 1024 / 1024)
        End If

        ToolTip.SetToolTip(sender, sCaption)
    End Sub
    Private Sub lblTime_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles lblTime.Click
        Dim timeinfo As String
        Dim t As Date
        t = Now()
        timeinfo = WeekdayName(Weekday(t, FirstDayOfWeek.Monday)) & ", " & Format(t, "dd") & vbCrLf & _
        MonthName(Month(t)) & " " & Format(t, "yyyy") & " г."
        ' отображаем в подсказке текущее число, день недели и год
        ToolTip.SetToolTip(lblTime, timeinfo)
    End Sub

    Private Sub Timer1_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer1.Tick
        BatteryStatusUpd() ' обновляем данные о состоянии электропитания
        If My.Computer.Network.IsAvailable = True Then  ' Проверяем статус сетевых подключений и 
            PictureBox2.Image = My.Resources.rPanel.NET.ToBitmap ' соответственно меняем значёк
            ToolTip.SetToolTip(PictureBox2, "Подключено")
            miConnect.Enabled = False
            miDisconnect.Enabled = True
        Else
            PictureBox2.Image = My.Resources.rPanel.netu.ToBitmap
            ToolTip.SetToolTip(PictureBox2, "Отключено")
            miDisconnect.Enabled = False
            miConnect.Enabled = True
        End If

    End Sub

    

    Private Sub ЗакрытьToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ЗакрытьToolStripMenuItem.Click
        End
    End Sub

    
    Private Sub ToolStripMenuItem1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ToolStripMenuItem1.Click
        AboutBox1.Show()
    End Sub

   
    Private Sub Button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button2.Click
        Dim p As System.Drawing.Point
        p.X = 0 : p.Y = Me.Button2.Height

        CMS1.Show(Me.Button2, p)
    End Sub

    Private Sub Button3_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button3.Click
        Dim p As System.Drawing.Point
        p.X = 0 : p.Y = Me.Button3.Height

        CMS2.Show(Me.Button3, p)
    End Sub
End Class
