﻿Module mBattery
    Public cb As cbattery

    Public Structure BATTERY_STATUS_IMAGE 'структура для хранения значка батареи
        Dim Name As String
        Dim Location As Rectangle
        Dim Item As Bitmap

    End Structure

    Public BatteryIm(9) As BATTERY_STATUS_IMAGE 'Массив значков

    Public Enum BAT_STATUS_IMAGE As Integer ' перечисление типов значков
        BAT_FULL = 0
        BAT_MEDIUM = 1
        BAT_LOW = 2
        BAT_CRITICAL = 3
        BAT_UNCNOUN = 4
        BAT_NO_BATTERY = 5
        BAT_AC = 6
        BAT_CHARGE = 7
        BAT_AC_CHARGE = 8
        BAT_BATTERY = 9
    End Enum

    Public Sub BatteryStatusUpd()
        Dim s As String


        cb = New cbattery
        cb.UpdateBattery()
        
        If cb.ACPower Then
            s = cb.Percent & "%"
            frmBar.PictureBox1.Image = BatteryIm(BAT_STATUS_IMAGE.BAT_AC).Item ' Отображаем нужные значки батареи
        Else
            s = cb.Percent & "% - " & cb.BatRamane
            frmBar.PictureBox1.Image = BatteryIm(BAT_STATUS_IMAGE.BAT_BATTERY).Item
        End If

        
        If cb.IsCarging Then frmBar.PictureBox1.Image = BatteryIm(BAT_STATUS_IMAGE.BAT_AC_CHARGE).Item

        If cb.BatStatus = 1 And Not cb.ACPower Then frmBar.PictureBox1.Image = BatteryIm(BAT_STATUS_IMAGE.BAT_LOW).Item
        If cb.BatStatus = 2 And Not cb.ACPower Then frmBar.PictureBox1.Image = BatteryIm(BAT_STATUS_IMAGE.BAT_MEDIUM).Item
        If cb.BatStatus = 3 And Not cb.ACPower Then frmBar.PictureBox1.Image = BatteryIm(BAT_STATUS_IMAGE.BAT_FULL).Item
        If cb.BatStatus = 0 And Not cb.ACPower Then frmBar.PictureBox1.Image = BatteryIm(BAT_STATUS_IMAGE.BAT_UNCNOUN).Item

        ' отображаем текущий заряд в % и если работа от батареи - расчётное время работы.
        frmBar.ToolTip.SetToolTip(frmBar.PictureBox1, s)


    End Sub
End Module
