﻿Public Class frmDrive
    Private SelectIndex As Integer
    Private pDrive() As PictureBox



    Private Sub frmDrive_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Dim cDrive As System.IO.DriveInfo

        Dim sDrive As String
        Dim iCount As Integer
        Dim i As Integer

        iCount = My.Computer.FileSystem.Drives.Count

        ReDim pDrive(iCount)
        For i = 0 To iCount - 1
            sDrive = My.Computer.FileSystem.Drives.Item(i).ToString
            cDrive = My.Computer.FileSystem.GetDriveInfo(sDrive)
            pDrive(i) = New PictureBox

            Me.Controls.Add(pDrive(i))
            Select Case cDrive.DriveType
                Case IO.DriveType.Fixed
                    pDrive(i).Image = My.Resources.rPanel.HARD.ToBitmap
                Case IO.DriveType.CDRom
                    pDrive(i).Image = My.Resources.rPanel.CDDVD.ToBitmap
                Case IO.DriveType.Network
                    pDrive(i).Image = My.Resources.rPanel.NET.ToBitmap
                Case IO.DriveType.NoRootDirectory
                    pDrive(i).Image = My.Resources.rPanel.netu.ToBitmap
                Case IO.DriveType.Ram
                    pDrive(i).Image = My.Resources.rPanel.RAM.ToBitmap
                Case IO.DriveType.Removable
                    pDrive(i).Image = My.Resources.rPanel.usb.ToBitmap
                Case IO.DriveType.Unknown
                    pDrive(i).Image = My.Resources.rPanel.usb.ToBitmap
            End Select

            pDrive(i).Left = 10 '+ i * pDrive(i).Height
            pDrive(i).Top = 10 + i * (pDrive(i).Height + 5)
            pDrive(i).BorderStyle = BorderStyle.None
            pDrive(i).BackColor = Color.Transparent
            'pDrive(i).ContextMenuStrip = mnuDisk
            pDrive(i).Tag = sDrive
            'pDrive(i).Tag = i
            'Me.Height = pDrive(i).Top + pDrive(i).Height + 10

        Next i
    End Sub
    Protected Overrides Sub WndProc(ByRef m As System.Windows.Forms.Message)
        Select Case m.Msg
            Case WM_NCHITTEST
                m.Result = IntPtr.op_Explicit(HTCAPTION)
                Return

        End Select
        MyBase.WndProc(m)
    End Sub
    

    



    
End Class






